.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include rlepkr.inc


.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke heapallocate
	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==1001
			   invoke Convert,hWin
			.elseif eax==1008
			   invoke Extract,hWin
			.elseif eax==1011
				invoke GetFileName, addr FilterString
				invoke SetDlgItemText,hWin,1012, addr fileName
				invoke lstrcpy,addr fname, addr fileName
			.elseif eax==1013
				invoke GetFileNameB, addr FilterString
				invoke SetDlgItemText,hWin,1014, addr fileName
				invoke lstrcpy, addr resname, addr fileName
			.elseif eax==1015   ;prescan  and 1016 = textbox to display #of repeats
				invoke LoadFile,hWin
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
		invoke cleanup
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

LoadFile proc hWin:DWORD
LOCAL hF:DWORD
	invoke CreateFile, addr fname, GENERIC_READ,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov hF,eax

	invoke ReadFile,hF, DTAIN, 5000000, addr bread,NULL
	invoke CloseHandle,hF
		
	invoke TABULATE,hWin,bread
	ret
LoadFile endp

Convert proc hWin:DWORD
LOCAL hF:DWORD
	invoke CreateFile, addr fname, GENERIC_READ,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov hF,eax

	invoke ReadFile,hF, DTAIN, 5000000, addr bread,NULL
	invoke CloseHandle,hF
	
	invoke SetDlgItemInt,hWin,1004,bread,NULL

	invoke RLE_ENCODE_2, bread  ;should call gen_key first to generate key
	push eax
	invoke SetDlgItemInt,hWin,1005,eax,NULL
	invoke SetDlgItemText,hWin,1003,  DTAOUT

	invoke CreateFile,addr ofname, GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov hF,eax
	pop eax
	invoke WriteFile,hF,DTAOUT,eax,addr bread,NULL
	invoke CloseHandle,hF
	
	ret

Convert endp

Extract proc hWin:DWORD
LOCAL hF:DWORD
LOCAL sav1:DWORD
	push hWin
	pop g_hWin
	
	invoke CreateFile, addr ofname, GENERIC_READ,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov hF,eax

	invoke ReadFile,hF, DTAEXTRACT, 5000000, addr bread,NULL
	invoke CloseHandle,hF
	
	invoke SetDlgItemInt,hWin,1004,bread,NULL

	invoke RLE_DECODE_2, bread
	mov sav1,eax
	invoke SetDlgItemInt,hWin,1005,eax,NULL
	invoke SetDlgItemText,hWin,1002,  DTAOUT

	invoke CreateFile,addr resname, GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov hF,eax

	invoke WriteFile,hF,DTAOUT,sav1,addr bread,NULL
	invoke CloseHandle,hF
	
	ret

Extract endp

GEN_KEY proc dwcnt:DWORD
	push esi
	xor edx,edx
	mov dl,'A'
	mov dh,'B'

reset:
	xor ecx,ecx
	add dl,1
	mov esi,DTAIN
	cmp dl,255
	jb loop1
	mov dl,0
	add dh,1
	cmp dh,255
	jb loop1
	 
	
loop1:
	cmp ecx,dwcnt
	jae donewidis
	mov al, byte ptr [esi+ecx]
	add ecx,1
	cmp al, dl
	jne loop1
	mov al, byte ptr [esi+ecx]
	add ecx,1
	cmp al, dh
	jne loop1    ;if =='A' and =='B' within file, then
 	jmp reset    ;start over, add 1 to 'A' making it a 'B', then look again
 
donewidis:		;until we is done wid disss......
    mov eax,1
    pop esi

	ret
GEN_KEY endp

RLE_ENCODE_2 proc cbSource:DWORD
	
	local	pSingleStart:	dword	;pointer to start of single bytes
	local	pSequenceStart:	dword	;pointer to start of repeating bytes

	inc cbSource
	mov esi, DTAIN
	mov edi, DTAOUT
	xor ecx, ecx 

	mov pSequenceStart, 0
	mov pSingleStart, 0

.repeat				;Main Loop
	
	mov al, [esi]			;current byte


   ;=== byte is repeating===
	.if [esi+1] == al		
		
		.if !pSequenceStart		;it's the first byte of a series
			.if [esi+2] == al	;ensure min 3-byte sequence
				mov pSequenceStart, esi	;save pointer to start of series
			.else			;<3 same bytes, treat as singletons
				jmp Singletons
			.endif
		.endif
		
		.if pSingleStart		;end of chain of singletons
			push esi
			push ecx

			mov ecx, esi
			sub ecx, pSingleStart	;cb of singletons
			mov esi, offset TempBuffer	;ptr to saved singletons

			.while ecx > 127
				mov byte ptr[edi], 01111111b	;max single chars - 127 (LSB clear)
				inc edi
				push ecx
				mov ecx, 127
				cld
				rep movsb	;copy 127 singletons
				pop ecx
				sub ecx, 127
			.endw
			
			mov byte ptr[edi], cl		;cb of singletons (LSB clear)
			inc edi
			cld
			rep movsb

			pop ecx
			pop esi	
			mov pSingleStart, 0		;clear pointer (end of singetons)
		.endif

   ;=== not repeating ===
	.else
		
Singletons:		
	;--- End of a repeating series---
		.if pSequenceStart	
			mov edx, esi
			sub edx, pSequenceStart	;edx = number of repeating bytes
			add edx, 1
		;--- we can only represent a max of 130 with one entry ---
			.while edx > 130
				mov byte ptr[edi], 0ffh	;130 repetitions
				mov byte ptr[edi+1], al	;of <byte>
				add edi, 2
				sub edx, 130
			.endw

		;--- now edx < 130 ---
			or dl, 10000000b	;set MSB (aka escape for sequence)
			sub dl, 3
			mov byte ptr[edi], dl	;number of repetitions
			mov byte ptr[edi+1], al	;of <byte>
			add edi, 2
			mov pSequenceStart, 0	;clear pointer (end of series)


	;--- Single Instance of Byte ---
		.else					;al = single instance @ [esi] 

			.if !pSingleStart		;first singleton in series	
				mov pSingleStart, esi	;save pointer to start of singletons
			.endif			
	
				mov edx, esi
				sub edx, pSingleStart	;index into temp buffer
				add edx, offset TempBuffer
				mov [edx], al		;save singleton in tempbuffer
		.endif
	.endif
	inc esi
	inc ecx

.until ecx == cbSource
	ret

RLE_ENCODE_2 endp

RLE_ENCODE proc dwcnt:DWORD
;simple byte - compression, wait till we get to dwords  :P~~~~~~
LOCAL sav1:BYTE
LOCAL sav2:BYTE
LOCAL sav3:BYTE
LOCAL keyh:BYTE
LOCAL keyl:BYTE
LOCAL holdv:DWORD
;...................

 invoke GEN_KEY, dwcnt
 mov keyh,dh   ;'B'
 mov keyl,dl   ;'A'

	invoke SetDlgItemInt,g_hWin,1009,keyl,NULL
 	invoke SetDlgItemInt,g_hWin,1010,keyh,NULL
 
 push edi
 push esi

 xor eax,eax
 xor ebx,ebx

 mov esi,DTAIN
 mov edi,DTAOUT
 sub dwcnt,1
 xor edx,edx

 mov ch,keyh
 mov cl,keyl
 mov byte ptr [edi+edx],cl
 add edx,1
 mov byte ptr [edi+edx],ch
 add edx,1
 xor ecx,ecx


mainloop:
 xor ebx,ebx
loopA:
 cmp ecx,dwcnt
 jg dropdis
 
 mov al, BYTE PTR [esi+ecx]
 mov sav1, al  ;store first initial read
 add ecx,1
 mov holdv,ecx

loopAE:  ;this part works
 mov ah, byte ptr [esi+ecx]  ;see if it is loopy
 add ecx,1
 add bl,1
 cmp ebx,250  ;make sure you don't overflow 255 since we are doing byte-compression
 jg dropdown
 cmp al,ah        ;if so keep on a loopin until not equal
 je loopAE
;pick up any leftovers
 sub ecx,1
 mov ah, byte ptr [esi+ecx]
;..................
dropdown:
.if bl > 3
    push ecx
    xor ecx,ecx
    mov cl,keyl
	mov byte ptr [edi+edx], cl  ;'A'
	mov ch,keyh
	add edx,1
	mov byte ptr [edi+edx], ch   ;'B'
	pop ecx
	add edx,1
	mov byte ptr [edi+edx], bl
	add edx,1
	mov al,sav1
	mov byte ptr [edi+edx], al
	add edx,1
	mov byte ptr [edi+edx], ah
	jmp mainloop
.else
    mov al, sav1
    mov byte ptr [edi+edx], al
    add edx,1
	mov ecx,holdv
    jmp mainloop
.endif

dropdis:
 pop esi
 pop edi
 mov eax,edx
 ret


RLE_ENCODE endp

RLE_DECODE_2 proc cbSource:DWORD
	
	inc cbSource
	mov ecx, 0
	mov esi, DTAEXTRACT
	mov edi, DTAOUT
.repeat
	mov al, [esi]
	.if (al & 10000000b)	;unpack
		and al, 01111111b	;get byte count
		push ecx
		xor ecx, ecx
		mov cl, al
		add cl, 3
		mov al, [esi+1]		;byte to copy
		cld
		rep stosb
		pop ecx
		add esi, 2
	.else			;string of single bytes
		push ecx
		xor ecx, ecx
		mov cl, al	;byte count
		inc esi		;ptr to start of bytes to copy
		cld
		rep movsb
		pop ecx
	.endif

inc ecx

.until ecx == cbSource
	ret

RLE_DECODE_2 endp
RLE_DECODE proc dwcnt:DWORD
LOCAL sav1:BYTE
LOCAL sav2:BYTE
LOCAL keyh:BYTE
LOCAL keyl:BYTE

	push edi
	push esi
	xor eax,eax
	xor ebx,ebx
	xor ecx,ecx
	xor edx,edx
	mov esi,DTAEXTRACT
	mov edi,DTAOUT
    sub dwcnt,1

	mov bl, byte ptr [esi+ecx]
	mov keyl,bl
	add ecx,1
	mov bl,byte ptr [esi+ecx]
	mov keyh,bl
	add ecx,1
	

mainloop:
	xor ebx,ebx
loopA:
	cmp ecx,dwcnt
	ja dropdis  ;jump if greater than, don't test for sign
	mov al, byte ptr [esi+ecx]    ;move byte in source+counter to al register
	mov sav1,al
	add ecx,1                     ;add 1 to the counter
	cmp al,keyl  ;if == 'A' then jump, else write it out
	je next1

goback:
	mov byte ptr [edi+edx], al
	add edx,1
	jmp loopA
	
next1:
	mov ah, byte ptr [esi+ecx]
	mov sav2,ah
	cmp ah,keyh  ;if == 'B' then continue else
	jne goback   ;if != 'B' then go back
	add ecx,1
	
    mov al, byte ptr [esi+ecx]
    add ecx,1
    mov ah, byte ptr [esi+ecx]
    add ecx,1
	push ecx
	xor ecx,ecx
	
	cmp al,251
	jne loopherenow
	mov byte ptr [edi+edx],ah
	add edx,1
loopherenow:
    mov byte ptr [edi+edx],ah
    add edx,1
	add ecx,1
	cmp cl,al
	jb loopherenow
	pop ecx
	jmp loopA

dropdis:
	pop esi
	pop edi
	mov eax,edx
	ret

RLE_DECODE endp

TABULATE proc hWin:DWORD, dwcnt:DWORD
	push edi
	push esi
	mov esi, DTAIN
	mov edi, DTAOUT

	invoke SetDlgItemText,hWin,1002,DTAIN

	xor eax,eax
	xor ebx,ebx
	xor ecx,ecx
	xor edx,edx

firstread:
	add ecx,8    ;if ah=0 and al=0, then for some reason it gets error..,.
	mov ah, byte ptr [esi+ecx]
;	mov ecx,0
loopit1:		
	mov al, byte ptr [esi+ecx]
	add ecx,1
	cmp al,ah
	je addit
	cmp ecx,dwcnt
	jbe loopit1
	jmp doneit

addit:
	add ebx,1
	jmp loopit1

doneit:

	invoke SetDlgItemInt, hWin, 1016, ebx, NULL

	pop esi
	pop edi
	ret
TABULATE endp

GetFileName proc pszFilter:DWORD
	invoke RtlZeroMemory, addr ofn, sizeof ofn
	mov ofn.lStructSize, sizeof ofn
	mov eax, g_hWin
	mov ofn.hwndOwner, eax
	mov eax, pszFilter
	mov ofn.lpstrFilter, eax
	mov ofn.nFilterIndex, 1
	lea eax, [fileName]
	mov ofn.lpstrFile, eax
	mov ofn.nMaxFile, sizeof fileName
	mov ofn.Flags,  OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_HIDEREADONLY
	invoke GetOpenFileName, addr ofn
;	.if eax == TRUE
;		invoke MessageBox,NULL, addr buffer,ADDR buffer,MB_OK
;	.endif
	ret
GetFileName endp

GetFileNameB proc pszFilter:DWORD
	invoke RtlZeroMemory, addr ofn, sizeof ofn
	mov ofn.lStructSize, sizeof ofn
	mov eax, g_hWin
	mov ofn.hwndOwner, eax
	mov eax, pszFilter
	mov ofn.lpstrFilter, eax
	mov ofn.nFilterIndex, 1
	lea eax, [fileName]
	mov ofn.lpstrFile, eax
	mov ofn.nMaxFile, sizeof fileName
	mov ofn.Flags,  OFN_PATHMUSTEXIST+OFN_HIDEREADONLY
	invoke GetOpenFileName, addr ofn
;	.if eax == TRUE
;		invoke MessageBox,NULL, addr buffer,ADDR buffer,MB_OK
;	.endif
	ret
GetFileNameB endp
heapallocate proc

	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,5000000
	mov [DTAIN],eax
	
	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,5000000
	mov [DTAOUT],eax

	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,5000000
	mov [DTAEXTRACT],eax

	ret
heapallocate endp
cleanup proc
	invoke GetProcessHeap
	invoke HeapFree, eax, NULL, DTAOUT

	invoke GetProcessHeap
	invoke HeapFree, eax, NULL, DTAIN
	
	invoke GetProcessHeap
	invoke HeapFree, eax, NULL, DTAEXTRACT
	ret
cleanup endp

end start
